//Score pins player 1
static int ledPinBlue3 = 2;
static int ledPinBlue2 = 4;
static int ledPinBlue1 = 7;
static int ledPinBlueON = 5;

static int ledPinYellow = 6;

//Score pins player 2
static int ledPinRedON = 9;
static int ledPinRed1 = 8;
static int ledPinRed2 = 12;
static int ledPinRed3 = 13;

//button pins players
static int buttonPin1 = 3;
static int buttonPin2 = 11;
static int buttonPin3 = 10;

int buttonState1 = 0;             //Player 1
int buttonState2 = 0;             //Player 2

int buttonState3 = 0;             //On/Off button
int lastButtonState3 = 0;

int scorePlayer1;
int scorePlayer2;

bool buttonPressed = false;

bool reactStart = true;
int reactTimer;
int reactNum;
int prevMills;

bool startGame = true;

void setup() 
{
  Serial.begin(9600);
  pinMode(ledPinBlueON, OUTPUT);
  
  pinMode(ledPinBlue1, OUTPUT);
  pinMode(ledPinBlue2, OUTPUT);
  pinMode(ledPinBlue3, OUTPUT);
  
  pinMode(ledPinYellow, OUTPUT);

  pinMode(ledPinRedON, OUTPUT);
  
  pinMode(ledPinRed1, OUTPUT);
  pinMode(ledPinRed2, OUTPUT);
  pinMode(ledPinRed3, OUTPUT);
  
  pinMode(buttonPin1, INPUT);
  pinMode(buttonPin2, INPUT);
  pinMode(buttonPin3, INPUT);  
}

void loop() 
{
  delay(20);
  buttonState1 = digitalRead(buttonPin1);
  buttonState2 = digitalRead(buttonPin2);  
  buttonState3 = digitalRead(buttonPin3);
  
  lastButtonState3 = buttonState3;
  
  if(startGame == true)
  {    
    reactTimer = (millis() / 1000) - prevMills;
  
    Serial.println(reactTimer);
    
    Lights();
  
    if(reactStart == true)
    {
      reactNum = random(2,20);
      reactStart = false;
      prevMills = millis() / 1000; 
    }
    
    if(buttonPressed == false)
    {
      Score1();
    }
  
    if(buttonPressed == false)
    {    
      Score2();
    }
    
    if(reactTimer == reactNum)
    {
      RandomTrigger();
    }
  
    if(scorePlayer1 >=3)
    {
      BlueEndGame();
    }
    if(scorePlayer2 >=3)
    {
      RedEndGame();
    }
  }
}


void RandomTrigger()
{
  digitalWrite(ledPinYellow, HIGH);
  buttonPressed = false;
}


void Score1()
{
  if(buttonState1 == HIGH)
  {
    scorePlayer1 ++;
    buttonPressed = true;
    digitalWrite(ledPinYellow, LOW);
    reactStart = true;
    reactTimer = 0;
  }
}

void Score2()
{
  if(buttonState2 == HIGH)
  {
    scorePlayer2 ++;
    buttonPressed = true;
    digitalWrite(ledPinYellow, LOW);
    reactStart = true;
    reactTimer = 0;
  }
}

void Lights()
{
  //Blue Lights (PLAYER1)  
  digitalWrite(ledPinBlueON, HIGH);
  if(scorePlayer1 >= 1)
  {    
    digitalWrite(ledPinBlue1, HIGH);
  }
  if(scorePlayer1 >= 2)
  {    
    digitalWrite(ledPinBlue2, HIGH);
  }
  if(scorePlayer1 >= 3)
  {    
    digitalWrite(ledPinBlue3, HIGH);
  }
  
  //Red Lights (PLAYER2)
  digitalWrite(ledPinRedON, HIGH);
  if(scorePlayer2 >= 1)
  {    
    digitalWrite(ledPinRed1, HIGH);
  }
  if(scorePlayer2 >= 2)
  {    
    digitalWrite(ledPinRed2, HIGH);
  }
  if(scorePlayer2 >= 3)
  {    
    digitalWrite(ledPinRed3, HIGH);
  }
}

void BlueEndGame()
{
  digitalWrite(ledPinBlue1, LOW);
  digitalWrite(ledPinBlue2, LOW);
  digitalWrite(ledPinBlue3, LOW);
   
  digitalWrite(ledPinRed1, LOW);
  digitalWrite(ledPinRed2, LOW);
  digitalWrite(ledPinRed3, LOW);

  delay(100);

  digitalWrite(ledPinBlue1, HIGH);
  digitalWrite(ledPinBlue2, HIGH);
  digitalWrite(ledPinBlue3, HIGH);

  delay(100);

  digitalWrite(ledPinBlue1, LOW);
  digitalWrite(ledPinBlue2, LOW);
  digitalWrite(ledPinBlue3, LOW);

  delay(100);

  digitalWrite(ledPinBlue1, HIGH);
  digitalWrite(ledPinBlue2, HIGH);
  digitalWrite(ledPinBlue3, HIGH);

  delay(1000);

  digitalWrite(ledPinBlue1, LOW);
  digitalWrite(ledPinBlue2, LOW);
  digitalWrite(ledPinBlue3, LOW);
  scorePlayer1 = 0;
  scorePlayer2 = 0;
}

void RedEndGame()
{
  digitalWrite(ledPinRed1, LOW);
  digitalWrite(ledPinRed2, LOW);
  digitalWrite(ledPinRed3, LOW);  
  
  digitalWrite(ledPinBlue1, LOW);
  digitalWrite(ledPinBlue2, LOW);
  digitalWrite(ledPinBlue3, LOW);

  delay(100);

  digitalWrite(ledPinRed1, HIGH);
  digitalWrite(ledPinRed2, HIGH);
  digitalWrite(ledPinRed3, HIGH);

  delay(100);

  digitalWrite(ledPinRed1, LOW);
  digitalWrite(ledPinRed2, LOW);
  digitalWrite(ledPinRed3, LOW);

  delay(100);

  digitalWrite(ledPinRed1, HIGH);
  digitalWrite(ledPinRed2, HIGH);
  digitalWrite(ledPinRed3, HIGH);

  delay(1000);

  digitalWrite(ledPinRed1, LOW);
  digitalWrite(ledPinRed2, LOW);
  digitalWrite(ledPinRed3, LOW);
  scorePlayer1 = 0;
  scorePlayer2 = 0;
  
}


